{
   muu TrueColor library for TMT Pascal - Nova MMX direct copy routines
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

PROCEDURE Nmmx_DIRECT4(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
ASM
    fwait   // make sure FPU isn't running

    mov  esi,  src
    mov  edi,  tgt
    mov  ebx,  hgt
    
@@line_loop:
    mov  ecx,  wdt
    mov  edx,  wdt
    shr  ecx,  4
    jz   @@no_opt

@@move_opt:
    movq mm0,  [esi]
    movq mm1,  [esi+8]

    movq [edi],  mm0
    movq [edi+8],  mm1
    
    add  esi,  16
    add  edi,  16
    dec  ecx
    jnz  @@move_opt

@@no_opt:
    and  edx,  15
    jz   @@no_comp

@@move_comp:    // moves remaining bytes which doesn't match 2xqword
    mov  ecx,  edx
    rep  movsb

@@no_comp:
    add  esi,  snl
    add  edi,  tnl
    dec  ebx
    jnz  @@line_loop

    emms    // shut down MMX
END;
